 
 
 
 
 
 
 
 
 
 
 
 





 
 
 

 

#pragma datloc reg

struct _HSI_MODE_Bits
{
 unsigned char HSI0_MODE :2;
 unsigned char HSI1_MODE :2;
 unsigned char HSI2_MODE :2;
 unsigned char HSI3_MODE :2;
};

extern volatile unsigned char HSI_MODE;
extern volatile struct _HSI_MODE_Bits HSI_MODE_Bits;


 

struct _HSI_STATUS_Bits
{
 unsigned char HSI0_EVENT :1; 
 unsigned char HSI0_STAT :1; 
 unsigned char HSI1_EVENT :1; 
 unsigned char HSI1_STAT :1; 
 unsigned char HSI2_EVENT :1; 
 unsigned char HSI2_STAT :1; 
 unsigned char HSI3_EVENT :1; 
 unsigned char HSI3_STAT :1; 
};

extern volatile unsigned char HSI_STATUS;
extern volatile struct _HSI_STATUS_Bits HSI_STATUS_Bits;


 

struct _HSI_TIME_Bits
{
 unsigned int HSI_TIME_LO :8;
 unsigned int HSI_TIME_HI :8;
};

extern volatile unsigned int HSI_TIME;
extern volatile struct _HSI_TIME_Bits HSI_TIME_Bits;


 

extern volatile unsigned char HSI_TIME_LO;


 

extern volatile unsigned char HSI_TIME_HI;


 

struct _INT_MASK_Bits
{
 unsigned char TIMER_MASK :1; 
 unsigned char AD_MASK :1; 
 unsigned char HSIDAT_MASK :1; 
 unsigned char HSO_MASK :1; 
 unsigned char HSIO_MASK :1; 
 unsigned char SWT_MASK :1; 
 unsigned char SER_MASK :1; 
 unsigned char EXTINT_MASK :1; 
};

extern volatile unsigned char INT_MASK;
extern volatile struct _INT_MASK_Bits INT_MASK_Bits;


 

struct _INT_MASK1_Bits
{
 unsigned char TI_RI_MASK :1; 
 unsigned char BSI_MASK :1; 
 unsigned char HSI4_MASK :1; 
 unsigned char T2CAP_MASK :1; 
 unsigned char T2OVF_MASK :1; 
 unsigned char EXTINT1_MASK :1; 
 unsigned char FIFO_MASK :1; 
};

extern volatile unsigned char INT_MASK1;
extern volatile struct _INT_MASK1_Bits INT_MASK1_Bits;


 

struct _IOC0_Bits
{
 unsigned char HSI0_ENA :1; 
 unsigned char SW_T2RST :1; 
 unsigned char HSI1_ENA :1; 
 unsigned char T2RST_ENA :1; 
 unsigned char HSI2_ENA :1; 
 unsigned char T2RST_SRC :1; 
 unsigned char HSI3_ENA :1; 
 unsigned char T2CLK_SRC :1; 
};

extern volatile unsigned char IOC0;
extern volatile struct _IOC0_Bits IOC0_Bits;


 

struct _IOC1_Bits
{
 unsigned char PWM_SEL :1; 
 unsigned char :1; 
 unsigned char T1OVF_INT :1; 
 unsigned char T2OVF_INT :1; 
 unsigned char HSO4_ENA :1; 
 unsigned char :1; 
 unsigned char HSO5_ENA :1; 
 unsigned char HSI_INT :1; 
};

extern volatile unsigned char IOC1;
extern volatile struct _IOC1_Bits IOC1_Bits;


 

struct _IOS1_Bits
{
 unsigned char SWTF0 :1; 
 unsigned char SWTF1 :1; 
 unsigned char SWTF2 :1; 
 unsigned char SWTF3 :1; 
 unsigned char :1; 
 unsigned char T1_OVF :1; 
 unsigned char :1; 
 unsigned char HSI_RDY :1; 
};

extern volatile unsigned char IOS1;
extern volatile struct _IOS1_Bits IOS1_Bits;


 

struct _IOC2_Bits
{
 unsigned char FAST_T2_ENA :1; 
 unsigned char T2UD_ENA :1; 
 unsigned char SLOW_PWM :2; 
 unsigned char :1; 
 unsigned char T2ALT_INT :1; 
 unsigned char LOCK_ENA :1;
 unsigned char CAM_CLR :1;
};

extern volatile unsigned char IOC2;
extern volatile struct _IOC2_Bits IOC2_Bits;


 

struct _HSO_COMMAND_Bits
{
 unsigned char CMD_TAG :4; 
 unsigned char HSOINT_ENA :1; 
 unsigned char PIN_CMD :1; 
 unsigned char TIMER_SEL :1; 
 unsigned char CAM_LOCK :1; 
};

extern volatile unsigned char HSO_COMMAND;
extern volatile struct _HSO_COMMAND_Bits HSO_COMMAND_Bits;


 

extern volatile unsigned char HSO_TIME_LO;


 

extern volatile unsigned char HSO_TIME_HI;


 

struct _HSO_TIME_Bits
{
 unsigned int HSO_TIME_LO :8;
 unsigned int HSO_TIME_HI :8;
};

extern volatile unsigned int HSO_TIME;
extern volatile struct _HSO_TIME_Bits HSO_TIME_Bits;


 

struct _IOS0_Bits
{
 unsigned char HSO0_STAT :1; 
 unsigned char HSO1_STAT :1; 
 unsigned char HSO2_STAT :1; 
 unsigned char :1; 
 unsigned char HSO4_STAT :1; 
 unsigned char HSO5_STAT :1; 
 unsigned char HRCAM_STAT :1; 
 unsigned char HR_STAT :1; 
};

extern volatile unsigned char IOS0;
extern volatile struct _IOS0_Bits IOS0_Bits;


 

struct _IOS2_Bits
{
 unsigned char HSO0_EVENT :1; 
 unsigned char HSO1_EVENT :1; 
 unsigned char HSO2_EVENT :1; 
 unsigned char HSO3_EVENT :1; 
 unsigned char HSO4_EVENT :1; 
 unsigned char HSO5_EVENT :1; 
};

extern volatile unsigned char IOS2;
extern volatile struct _IOS2_Bits IOS2_Bits;


 

struct _PTSSEL_Bits
{
 unsigned int T1OVF_SEL :1;
 unsigned int AD_SEL :1;
 unsigned int HIS_DAT_SEL :1;
 unsigned int HSO_SEL :1;
 unsigned int HSIO_SEL :1;
 unsigned int SWT_SEL :1;
 unsigned int SER_SEL :1;
 unsigned int EXTINT_SEL :1;
 unsigned int TI_SEL :1;
 unsigned int RI_SEL :1;
 unsigned int HSI4_SEL :1;
 unsigned int T2CAP_SEL :1;
 unsigned int T2OVF_SEL :1;
 unsigned int EXTINT1_SEL :1;
 unsigned int FIFO_SEL :1; 
};

extern volatile unsigned int PTSSEL;
extern volatile struct _PTSSEL_Bits PTSSEL_Bits;


 

struct _PTSSEL_LO_Bits
{
 unsigned char T1OVF_SEL :1;
 unsigned char AD_SEL :1;
 unsigned char HIS_DAT_SEL :1;
 unsigned char HSO_SEL :1;
 unsigned char HSIO_SEL :1;
 unsigned char SWT_SEL :1;
 unsigned char SER_SEL :1;
 unsigned char EXTINT_SEL :1;
};

extern volatile unsigned char PTSSEL_LO;
extern volatile struct _PTSSEL_LO_Bits PTSSEL_LO_Bits;


 

struct _PTSSEL_HI_Bits
{
 unsigned char TI_SEL :1;
 unsigned char RI_SEL :1;
 unsigned char HSI4_SEL :1;
 unsigned char T2CAP_SEL :1;
 unsigned char T2OVF_SEL :1;
 unsigned char EXTINT1_SEL :1;
 unsigned char FIFO_SEL :1; 
};

extern volatile unsigned char PTSSEL_HI;
extern volatile struct _PTSSEL_HI_Bits PTSSEL_HI_Bits;


 

struct _PTSSRV_Bits
{
 unsigned int T1OVF_SRV :1; 
 unsigned int AD_SRV :1; 
 unsigned int HISDAT_SRV :1; 
 unsigned int HSO_SRV :1; 
 unsigned int HSIO_SRV :1; 
 unsigned int SWT_SRV :1; 
 unsigned int SER_SRV :1; 
 unsigned int EXTINT_SRV :1; 
 unsigned int TI_SRV :1; 
 unsigned int RI_SRV :1; 
 unsigned int HSI4_SRV :1; 
 unsigned int T2CAP_SRV :1; 
 unsigned int T2OVF_SRV :1; 
 unsigned int EXTINT1_SRV :1; 
 unsigned int FIFO_SRV :1; 
};

extern volatile unsigned int PTSSRV;
extern volatile struct _PTSSRV_Bits PTSSRV_Bits;


 

struct _PTSSRV_LO_Bits
{
 unsigned char T1OVF_SRV :1; 
 unsigned char AD_SRV :1; 
 unsigned char HISDAT_SRV :1; 
 unsigned char HSO_SRV :1; 
 unsigned char HSIO_SRV :1; 
 unsigned char SWT_SRV :1; 
 unsigned char SER_SRV :1; 
 unsigned char EXTINT_SRV :1; 
};

extern volatile unsigned char PTSSRV_LO;
extern volatile struct _PTSSRV_LO_Bits PTSSRV_LO_Bits;


 

struct _PTSSRV_HI_Bits
{
 unsigned char TI_SRV :1; 
 unsigned char RI_SRV :1; 
 unsigned char HSI4_SRV :1; 
 unsigned char T2CAP_SRV :1; 
 unsigned char T2OVF_SRV :1; 
 unsigned char EXTINT1_SRV :1; 
 unsigned char FIFO_SRV :1; 
};

extern volatile unsigned char PTSSRV_HI;
extern volatile struct _PTSSRV_HI_Bits PTSSRV_HI_Bits;


 

extern volatile unsigned char PWM0_CONTROL;


 

extern volatile unsigned char PWM1_CONTROL;


 

extern volatile unsigned char PWM2_CONTROL;


 

struct _INT_PEND_Bits
{
 unsigned char TIMER_PEND :1; 
 unsigned char AD_PEND :1; 
 unsigned char HSIDAT_PEND :1; 
 unsigned char HSO_PEND :1; 
 unsigned char HSIO_PEND :1; 
 unsigned char SWT_PEND :1; 
 unsigned char SER_PEND :1; 
 unsigned char EXTINT_PEND :1; 
};

extern volatile unsigned char INT_PEND;
extern volatile struct _INT_PEND_Bits INT_PEND_Bits;


 

struct _INT_PEND1_Bits
{
 unsigned char TI_RI_PEND :1; 
 unsigned char BSI_PEND :1; 
 unsigned char HSI4_PEND :1; 
 unsigned char T2CAP_PEND :1; 
 unsigned char T2OVF_PEND :1; 
 unsigned char EXTINT1_PEND :1; 
 unsigned char FIFO_PEND :1; 
 unsigned char NMI_PEND :1; 
};

extern volatile unsigned char INT_PEND1;
extern volatile struct _INT_PEND1_Bits INT_PEND1_Bits;


 

extern volatile unsigned char BAUD_RATE0;


 

extern volatile unsigned char SBUF_RX0;


 

extern volatile unsigned char SBUF_TX0;


 

struct _SP_CON0_Bits
{
 unsigned char SER_MODE0 :2; 
 unsigned char PEN0 :1; 
 unsigned char REN0 :1; 
 unsigned char TB80 :1; 
};

extern volatile unsigned char SP_CON0;
extern volatile struct _SP_CON0_Bits SP_CON0_Bits;


 

struct _SP_STAT0_Bits
{
 unsigned char :2; 
 unsigned char OE0 :1; 
 unsigned char TXE0 :1; 
 unsigned char FE0 :1; 
 unsigned char TI0 :1; 
 unsigned char RI0 :1; 
 unsigned char RPE0_RB80 :1; 
};

extern volatile unsigned char SP_STAT0;
extern volatile struct _SP_STAT0_Bits SP_STAT0_Bits;


 

struct _IOC3_Bits
{
 unsigned char T2_ENA :1; 
 unsigned char :1; 
 unsigned char SPWD_SEL :1; 
 unsigned char SPWS_SEL :1; 
};

extern volatile unsigned char IOC3;
extern volatile struct _IOC3_Bits IOC3_Bits;


 

struct _TIMER1_Bits
{
 unsigned int TIMER1_LO :8; 
 unsigned int TIMER1_HI :8; 
};

extern volatile unsigned int TIMER1;
extern volatile struct _TIMER1_Bits TIMER1_Bits;


 

extern volatile unsigned char TIMER1_LO;


 

extern volatile unsigned char TIMER1_HI;


 

struct _TIMER2_Bits
{
 unsigned int TIMER2_LO :8; 
 unsigned int TIMER2_HI :8; 
};

extern volatile unsigned int TIMER2;
extern volatile struct _TIMER2_Bits TIMER2_Bits;


 

extern volatile unsigned char TIMER2_LO;


 

extern volatile unsigned char TIMER2_HI;


 

struct _T2CAPTURE_Bits
{
 unsigned int T2_VALUE_LO :8; 
 unsigned int T2_VALUE_HI :8; 
};

extern volatile unsigned int T2CAPTURE;
extern volatile struct _T2CAPTURE_Bits T2CAPTURE_Bits;


 

extern volatile unsigned char T2CAPTURE_LO;


 

extern volatile unsigned char T2CAPTURE_HI;


 

extern volatile unsigned char WATCHDOG;


 

struct _WSR_Bits
{
 unsigned char W0 :1; 
 unsigned char W1 :1; 
 unsigned char W2 :1; 
 unsigned char W3 :1; 
 unsigned char W4 :1; 
 unsigned char W5 :1; 
 unsigned char W6 :1; 
};

extern volatile unsigned char WSR;
extern volatile struct _WSR_Bits WSR_Bits;



 
 
 

 

struct _ADC_IOPORT0_Bits
{
 unsigned char ACH0 :1; 
 unsigned char ACH1 :1; 
 unsigned char ACH2 :1; 
 unsigned char ACH3 :1; 
 unsigned char ACH4 :1; 
 unsigned char ACH5 :1; 
 unsigned char ACH6 :1; 
 unsigned char ACH7 :1; 
};

extern volatile unsigned char ADC_IOPORT0;
extern volatile struct _ADC_IOPORT0_Bits ADC_IOPORT0_Bits;


 

 

 

#pragma datloc mem

struct _ADC_IOPORT5_Bits
{
 unsigned char ACH8 :1; 
 unsigned char ACH9 :1; 
 unsigned char ACH10 :1; 
 unsigned char ACH11 :1; 
 unsigned char ACH12 :1; 
 unsigned char ACH13 :1; 
 unsigned char ACH14 :1; 
 unsigned char ACH15 :1; 
};

extern volatile unsigned char ADC_IOPORT5;
extern volatile struct _ADC_IOPORT5_Bits ADC_IOPORT5_Bits;


 

 

 

struct _ADC_EN_Bits
{
 unsigned char EN :1; 
 unsigned char :1; 
 unsigned char VMID_EN :1; 
 unsigned char :3; 
 unsigned char VMID_IN :1; 
 unsigned char VMID_OUT :1; 
};

extern volatile unsigned char ADC_EN;
extern volatile struct _ADC_EN_Bits ADC_EN_Bits;


 

 

 

struct _ADC_CON_Bits
{
 unsigned char START :1; 
 unsigned char MODE :2; 
 unsigned char CHANNEL :4; 
 unsigned char EN_DIF :1; 
};

extern volatile unsigned char ADC_CON;
extern volatile struct _ADC_CON_Bits ADC_CON_Bits;


 

 

 

struct _ADC_RESULT_Bits
{
 unsigned int DATA :14; 
 unsigned int :1; 
 unsigned int BUSY :1; 
};

extern volatile unsigned int ADC_RESULT;
extern volatile struct _ADC_RESULT_Bits ADC_RESULT_Bits;


 

 

 

struct _ADC_TRSCHAN_Bits
{
 unsigned int CONV_CHAN :4; 
};

extern volatile unsigned int ADC_TRSCHAN;
extern volatile struct _ADC_TRSCHAN_Bits ADC_TRSCHAN_Bits;


 

 

 

struct _ADC_SET_Bits
{
 unsigned char :3; 
 unsigned char ADC_CLK :3; 
};

extern volatile unsigned char ADC_SET;
extern volatile struct _ADC_SET_Bits ADC_SET_Bits;


 

 

 
 
 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 
 
 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 
 
 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 

 


 

 
typedef volatile struct
{
 unsigned char PTSCOUNT;
 unsigned char PTSCON_TRNS;
 union
 {
 unsigned char LO;
 unsigned char HI;
 }PTSSRC;
 union
 {
 unsigned char LO;
 unsigned char HI;
 }PTSDST;
 unsigned char RESERVED1;
 unsigned char RESERVED2;
}PTS_PTSCB_ST_TypeDef;

 
typedef volatile struct
{
 unsigned char PTSCOUNT;
 unsigned char PTSCON_TRNS;
 union
 {
 unsigned char LO;
 unsigned char HI;
 }PTSSRC;
 union
 {
 unsigned char LO;
 unsigned char HI;
 }PTSDST;
 unsigned char PTSBLOCK;
 unsigned char RESERVED;
}PTS_PTSCB_BT_TypeDef;

 
typedef volatile struct
{
 unsigned char PTSCOUNT;
 unsigned char PTSCON_HS;
 union
 {
 unsigned char LO;
 unsigned char HI;
 }PTSSRC;
 unsigned char RESERVED1;
 unsigned char RESERVED2;
 unsigned char PTSBLOCK;
 unsigned char RESERVED3;
}PTS_PTSCB_HSO_TypeDef;

 
typedef volatile struct
{
 unsigned char PTSCOUNT;
 unsigned char PTSCON_HS;
 union
 {
 unsigned char LO;
 unsigned char HI;
 }PTSDST;
 unsigned char RESERVED1;
 unsigned char RESERVED2;
 unsigned char PTSBLOCK;
 unsigned char RESERVED3;
}PTS_PTSCB_HSI_TypeDef;

 
 
 

 
 
 

 

 

 

 

 

 

 
 
 

 

#pragma datloc reg

struct _IOPORT0_Bits
{
 unsigned char PIN0 :1; 
 unsigned char PIN1 :1; 
 unsigned char PIN2 :1; 
 unsigned char PIN3 :1; 
 unsigned char PIN4 :1; 
 unsigned char PIN5 :1; 
 unsigned char PIN6 :1; 
 unsigned char PIN7 :1; 
};

extern volatile unsigned char IOPORT0;
extern volatile struct _IOPORT0_Bits IOPORT0_Bits;


 

struct _IOPORT1_Bits
{
 unsigned char PIN0 :1; 
 unsigned char PIN1 :1; 
 unsigned char PIN2 :1; 
 unsigned char PIN3 :1; 
 unsigned char PIN4 :1; 
 unsigned char PIN5 :1; 
 unsigned char PIN6 :1; 
 unsigned char PIN7 :1; 
};

extern volatile unsigned char IOPORT1;
extern volatile struct _IOPORT1_Bits IOPORT1_Bits;


 

struct _IOPORT2_Bits
{
 unsigned char PIN0 :1; 
 unsigned char PIN1 :1; 
 unsigned char PIN2 :1; 
 unsigned char PIN3 :1; 
 unsigned char PIN4 :1; 
 unsigned char PIN5 :1; 
 unsigned char PIN6 :1; 
 unsigned char PIN7 :1; 
};

extern volatile unsigned char IOPORT2;
extern volatile struct _IOPORT2_Bits IOPORT2_Bits;


 

#pragma datloc mem

struct _IOPORT34_Bits
{
 unsigned int PIN0 :1; 
 unsigned int PIN1 :1; 
 unsigned int PIN2 :1; 
 unsigned int PIN3 :1; 
 unsigned int PIN4 :1; 
 unsigned int PIN5 :1; 
 unsigned int PIN6 :1; 
 unsigned int PIN7 :1; 
 unsigned int PIN8 :1; 
 unsigned int PIN9 :1; 
 unsigned int PIN10 :1; 
 unsigned int PIN11 :1; 
 unsigned int PIN12 :1; 
 unsigned int PIN13 :1; 
 unsigned int PIN14 :1; 
 unsigned int PIN15 :1; 
};

extern volatile unsigned int IOPORT34;
extern volatile struct _IOPORT34_Bits IOPORT34_Bits;


 

 

 

struct _IOPORT3_Bits
{
 unsigned char PIN0 :1; 
 unsigned char PIN1 :1; 
 unsigned char PIN2 :1; 
 unsigned char PIN3 :1; 
 unsigned char PIN4 :1; 
 unsigned char PIN5 :1; 
 unsigned char PIN6 :1; 
 unsigned char PIN7 :1; 
};

extern volatile unsigned char IOPORT3;
extern volatile struct _IOPORT3_Bits IOPORT3_Bits;


 

struct _IOPORT4_Bits
{
 unsigned char PIN0 :1; 
 unsigned char PIN1 :1; 
 unsigned char PIN2 :1; 
 unsigned char PIN3 :1; 
 unsigned char PIN4 :1; 
 unsigned char PIN5 :1; 
 unsigned char PIN6 :1; 
 unsigned char PIN7 :1; 
};

extern volatile unsigned char IOPORT4;
extern volatile struct _IOPORT4_Bits IOPORT4_Bits;


 

struct _IOPORT5_Bits
{
 unsigned char PIN0 :1; 
 unsigned char PIN1 :1; 
 unsigned char PIN2 :1; 
 unsigned char PIN3 :1; 
 unsigned char PIN4 :1; 
 unsigned char PIN5 :1; 
 unsigned char PIN6 :1; 
 unsigned char PIN7 :1; 
};

extern volatile unsigned char IOPORT5;
extern volatile struct _IOPORT5_Bits IOPORT5_Bits;


 
 
 

 

 

 

 

 

 

 
 
 

 

extern volatile unsigned char BAUD_RATE1;


 

extern volatile unsigned char SBUF_RX1;


 

extern volatile unsigned char SBUF_TX1;


 

struct _SP_CON1_Bits
{
 unsigned char SER_MODE1 :2; 
 unsigned char PEN1 :1; 
 unsigned char REN1 :1; 
 unsigned char TB80 :1; 
};

extern volatile unsigned char SP_CON1;
extern volatile struct _SP_CON1_Bits SP_CON1_Bits;


 

 

 

struct _SP_STAT1_Bits
{
 unsigned char :2; 
 unsigned char OE1 :1;
 unsigned char TXE1 :1;
 unsigned char FE1 :1;
 unsigned char TI1 :1;
 unsigned char RI1 :1;
 unsigned char RPE1_RB81 :1;
};

extern volatile unsigned char SP_STAT1;
extern volatile struct _SP_STAT1_Bits SP_STAT1_Bits;


 

 

 
 
 

 

struct _SPCR_Bits
{
 unsigned char SPR0 :1; 
 unsigned char SPR1 :1; 
 unsigned char CPHA :1; 
 unsigned char CPOL :1; 
 unsigned char MSTR :1; 
 unsigned char DORD :1; 
 unsigned char SPE :1; 
 unsigned char SPIE :1; 
};

extern volatile unsigned char SPCR;
extern volatile struct _SPCR_Bits SPCR_Bits;


 

 

 

struct _SPSR_Bits
{
 unsigned char ENH :1; 
 unsigned char DISSO :1; 
 unsigned char :3; 
 unsigned char LDEN :1; 
 unsigned char WCOL :1; 
 unsigned char SPIF :1; 
};

extern volatile unsigned char SPSR;
extern volatile struct _SPSR_Bits SPSR_Bits;


 

 

 

extern volatile unsigned char SPDR;


 
 
 

 

extern volatile unsigned char SMBSDA;


 

struct _SMBST_Bits
{
 unsigned char MODE :6; 
 unsigned char :1; 
 unsigned char INT :1; 
};

extern volatile unsigned char SMBST;
extern volatile struct _SMBST_Bits SMBST_Bits;


 

 

 

struct _SMBCST_Bits
{
 unsigned char BB :1; 
 unsigned char TOCDIV :2; 
 unsigned char TOERR :1; 
 unsigned char TSDA :1; 
 unsigned char TGSCL :1; 
 unsigned char PECNEXT :1;
 unsigned char PECFAULT :1;
};

extern volatile unsigned char SMBCST;
extern volatile struct _SMBCST_Bits SMBCST_Bits;


 

 

 

struct _SMBCTL1_Bits
{
 unsigned char START :1; 
 unsigned char STOP :1; 
 unsigned char INTEN :1; 
 unsigned char MOD :1;
 unsigned char ACK :1; 
 unsigned char GCMEN :1; 
 unsigned char SMBARE :1; 
 unsigned char CLRST :1; 
};

extern volatile unsigned char SMBCTL1;
extern volatile struct _SMBCTL1_Bits SMBCTL1_Bits;


 

 

 

struct _SMBADDR_Bits
{
 unsigned char ADDR :7; 
 unsigned char SAEN :1; 
};

extern volatile unsigned char SMBADDR;
extern volatile struct _SMBADDR_Bits SMBADDR_Bits;


 

 

 

struct _SMBCTL2_Bits
{
 unsigned char ENABLE :1; 
 unsigned char SCLFRQ :7; 
};

extern volatile unsigned char SMBCTL2;
extern volatile struct _SMBCTL2_Bits SMBCTL2_Bits;


 

 

 

extern volatile unsigned char SMBTOPR;


 

struct _SMBCTL3_Bits
{
 unsigned char S10ADR :3; 
 unsigned char S10EN :1; 
 unsigned char HSDIV :4; 
};

extern volatile unsigned char SMBCTL3;
extern volatile struct _SMBCTL3_Bits SMBCTL3_Bits;


 

 

 
 
 

 

struct _BSICONFIG_Bits
{
 unsigned int DIV :6; 
 unsigned int :2; 
 unsigned int TXDLEV :1; 
 unsigned int :2; 
 unsigned int RST :1; 
 unsigned int ASKDELAY :2; 
 unsigned int MODE :2; 
};

extern volatile unsigned int BSICONFIG;
extern volatile struct _BSICONFIG_Bits BSICONFIG_Bits;


 

 

 

extern volatile unsigned int BSISADDR;


 

extern volatile unsigned int BSISPACE;


 

struct _BSICON_CNRTL_Bits
{
 unsigned int :12; 
 unsigned int REPEN :1; 
 unsigned int SWITCHEN :1; 
 unsigned int STOP :1; 
 unsigned int START :1; 
};

extern volatile unsigned int BSICON_CNRTL;
extern volatile struct _BSICON_CNRTL_Bits BSICON_CNRTL_Bits;


 

 

 

struct _BSICON_TERM_Bits
{
 unsigned int TON :1; 
 unsigned int :3; 
 unsigned int TERR :1; 
 unsigned int :1; 
 unsigned int AERR :1; 
 unsigned int ABUSY :1; 
 unsigned int SERVREQ :1; 
 unsigned int B10EN :1; 
 unsigned int BCMSGEN :1; 
 unsigned int TADDR :5; 
};

extern volatile unsigned int BSICON_TERM;
extern volatile struct _BSICON_TERM_Bits BSICON_TERM_Bits;


 

 

 

struct _BSICON_MON_Bits
{
 unsigned int FREESPACE :8; 
 unsigned int WORDNUM :8; 
};

extern volatile unsigned int BSICON_MON;
extern volatile struct _BSICON_MON_Bits BSICON_MON_Bits;


 

 

 

struct _BSISTAT_CNRTL_Bits
{
 unsigned int DATACNT :5; 
 unsigned int SUBADDR :5; 
 unsigned int T_R :1; 
 unsigned int BCCMD :1; 
 unsigned int ALLMSGEND :1; 
 unsigned int TEMPTRANEND :1; 
 unsigned int CHGEN :1; 
 unsigned int DATAERR :1; 
};

extern volatile unsigned int BSISTAT_CNRTL;
extern volatile struct _BSISTAT_CNRTL_Bits BSISTAT_CNRTL_Bits;


 

 

 

struct _BSISTAT_TERM_Bits
{
 unsigned int DATACNT :5; 
 unsigned int SUBADDR :5; 
 unsigned int T_R :1; 
 unsigned int BCCMD :1; 
 unsigned int :1; 
 unsigned int CONCMD :1; 
 unsigned int CHGEN :1; 
 unsigned int DATAERR :1; 
};

extern volatile unsigned int BSISTAT_TERM;
extern volatile struct _BSISTAT_TERM_Bits BSISTAT_TERM_Bits;


 

 

 

extern volatile unsigned int BSISTAT_MON;


 
 
 

 

struct _SWCON_Bits
{
 unsigned int LINKEN :1; 
 unsigned int LINKSTART :1; 
 unsigned int LINKAUTO :1; 
 unsigned int :5; 
 unsigned int WDTIMEOUT :8; 
};

extern volatile unsigned int SWCON;
extern volatile struct _SWCON_Bits SWCON_Bits;


 

 

 

struct _SWDATAT_Bits
{
 unsigned int TRANSDATA :8; 
 unsigned int EOP_EEP :1; 
};

extern volatile unsigned int SWDATAT;
extern volatile struct _SWDATAT_Bits SWDATAT_Bits;


 

 

 

struct _SWDATAR_Bits
{
 unsigned int RECDATA :8; 
 unsigned int EOP_EEP :1; 
};

extern volatile unsigned int SWDATAR;
extern volatile struct _SWDATAR_Bits SWDATAR_Bits;


 

 

 

struct _SWCAPSTAT_Bits
{
 unsigned int CAPRX :8; 
 unsigned int CAPTX :8; 
};

extern volatile unsigned int SWCAPSTAT;
extern volatile struct _SWCAPSTAT_Bits SWCAPSTAT_Bits;


 

 

 

struct _SWTIMET_Bits
{
 unsigned int TRANSTIME :6; 
 unsigned int :2; 
 unsigned int TICK :1; 
};

extern volatile unsigned int SWTIMET;
extern volatile struct _SWTIMET_Bits SWTIMET_Bits;


 

 

 

struct _SWTIMER_Bits
{
 unsigned int RECTIME :6; 
 unsigned int :2; 
 unsigned int TIMEVALID :1; 
 unsigned int TIMEINVALID :1; 
};

extern volatile unsigned int SWTIMER;
extern volatile struct _SWTIMER_Bits SWTIMER_Bits;


 

 

 

struct _SWSTAT_Bits
{
 unsigned int STATE :3; 
 unsigned int LINKRUN :1; 
 unsigned int EEPREC :1; 
 unsigned int EOPREC :1; 
 unsigned int DATAREC :1; 
 unsigned int TIMEREC :1; 
 unsigned int PARERR :1; 
 unsigned int ESCERR :1; 
 unsigned int DISCON :1; 
 unsigned int CREDITERR :1; 
 unsigned int TBUFEMPTY :1; 
 unsigned int RBUFEMPTY :1; 
 unsigned int TBUFFULL :1; 
 unsigned int RBUFFULL :1; 
};

extern volatile unsigned int SWSTAT;
extern volatile struct _SWSTAT_Bits SWSTAT_Bits;


 

 

 

struct _SWINTMASK_Bits
{
 unsigned int :3; 
 unsigned int RUNINT :1; 
 unsigned int EEPINT :1; 
 unsigned int EOPINT :1; 
 unsigned int DATAINT :1; 
 unsigned int TIMEINT :1; 
 unsigned int PARINT :1; 
 unsigned int ESCINT :1; 
 unsigned int DISCONINT :1; 
 unsigned int CREDITINT :1; 
 unsigned int TBUFEMPINT :1; 
 unsigned int RBUFEMPINT :1; 
 unsigned int TBUFFULLINT :1; 
 unsigned int RBUFFULLINT :1; 
};

extern volatile unsigned int SWINTMASK;
extern volatile struct _SWINTMASK_Bits SWINTMASK_Bits;


 

 

 

 

 

 

 

 

 

 

 

 

 

 

 
 
 

 

 

 

 
 
 

 

struct _CLKC_Bits
{
 unsigned int UART0EN :1; 
 unsigned int HSIOEN :1; 
 unsigned int BSIEN :1; 
 unsigned int PTSEN :1; 
 unsigned int DEBUGEN :1; 
 unsigned int ADCEN :1; 
 unsigned int :1; 
 unsigned int SLOW :1; 
 unsigned int SPIEN :1; 
 unsigned int I2CEN :1; 
 unsigned int UART1EN :1; 
};

extern volatile unsigned int CLKC;
extern volatile struct _CLKC_Bits CLKC_Bits;


 

 

 

struct _CLKCL_Bits
{
 unsigned char UART0EN :1; 
 unsigned char HSIOEN :1; 
 unsigned char BSIEN :1; 
 unsigned char PTSEN :1; 
 unsigned char DEBUGEN :1; 
 unsigned char ADCEN :1; 
 unsigned char :1; 
 unsigned char SLOW :1; 
};

extern volatile unsigned char CLKCL;
extern volatile struct _CLKCL_Bits CLKCL_Bits;


 

 

 

struct _CLKCH_Bits
{
 unsigned char SPIEN :1; 
 unsigned char I2CEN :1; 
 unsigned char UART1EN :1; 
};

extern volatile unsigned char CLKCH;
extern volatile struct _CLKCH_Bits CLKCH_Bits;


 

 


#pragma datloc .

 
 
 
 
 
 
 
 
 
 






 

 

 


 

 





















































 




typedef struct {
 unsigned char CMD_EXEC_STATUS; 
 unsigned char SLAVE_SEL; 
 unsigned char BAUD_RATE; 
 unsigned char STATUS; 
 unsigned char CTRL; 
 unsigned char SEND_ADDR; 
 unsigned char SEND_DATA; 
 unsigned char RCV_ADDR_CMD; 
 unsigned char RCV_DATA; 
 unsigned char RCV_CRC; 
 } PMLC_CMD_LIST;








typedef struct {
 unsigned char IO_PORT_0; 
 unsigned char IO_PORT_1; 
 unsigned char IO_PORT_2; 
 unsigned char IO_PORT_3; 
 unsigned char IO_PORT_4; 
 unsigned char IO_PORT_5; 
 unsigned char IO_CFG_REG; 
 unsigned char ADC_GEN_0; 
 unsigned char ADC_GEN_1; 
 unsigned char ADC_GEN_2; 
 unsigned char CTRL_REG; 
 unsigned char STATUS_REG; 
 unsigned char ID_REG; 
 } pdev_status;


typedef struct {
 unsigned char IO_PORT_0; 
 unsigned char IO_PORT_1; 
 unsigned char IO_PORT_2; 
 unsigned char IO_PORT_3; 
 unsigned char IO_PORT_4; 

 unsigned char IO_CFG_REG; 



 unsigned char CTRL_REG; 
 unsigned char STATUS_REG; 
 unsigned char ID_REG; 
 } bcv03r_type;


typedef struct {

 unsigned char IO_PORT_1; 




 unsigned char IO_CFG_REG; 



 unsigned char CTRL_REG; 
 unsigned char STATUS_REG; 
 unsigned char ID_REG; 
 } bcv04r_type;


typedef struct {
 unsigned char IO_PORT_0; 
 unsigned char IO_PORT_1; 
 unsigned char IO_PORT_2; 
 unsigned char IO_PORT_3; 
 unsigned char IO_PORT_4; 
 unsigned char IO_PORT_5; 
 unsigned char IO_CFG_REG; 
 unsigned char ADC_GEN_0; 
 unsigned char ADC_GEN_1; 

 unsigned char CTRL_REG; 
 unsigned char STATUS_REG; 
 unsigned char ID_REG; 
 } bav03r_type;


typedef struct {
 unsigned char IO_PORT_0; 
 unsigned char IO_PORT_1; 
 unsigned char IO_PORT_2; 
 unsigned char IO_PORT_3; 
 unsigned char IO_PORT_4; 

 unsigned char IO_CFG_REG; 



 unsigned char CTRL_REG; 
 unsigned char STATUS_REG; 
 unsigned char ID_REG; 
 } bta05r_type;


typedef struct {
 unsigned char IO_PORT_0; 
 unsigned char IO_PORT_1; 
 unsigned char IO_PORT_2; 
 unsigned char IO_PORT_3; 
 unsigned char IO_PORT_4; 
 unsigned char IO_PORT_5; 
 unsigned char IO_CFG_REG; 



 unsigned char CTRL_REG; 
 unsigned char STATUS_REG; 
 unsigned char ID_REG; 
 } bta06r_type;





void PMLC_select_device (
 unsigned char pk_num, 
 unsigned char pdev_num, 
 PMLC_CMD_LIST *list_ptr 
 );


void PMLC_baud_rate (
 unsigned char BAUD_RATE0, 
 PMLC_CMD_LIST *list_ptr 
 );


unsigned char PMLC_cmd_exec (
 PMLC_CMD_LIST *list_ptr, 
 unsigned char addr, 
 unsigned char cmd, 
 unsigned char data, 
 unsigned char *pdev_reg 
 );


void PMLC_read_rcv_reg (
 PMLC_CMD_LIST *list_ptr 
 );
















































unsigned char init_bcv03r(
 PMLC_CMD_LIST *cmd_ptr, 
 bcv03r_type *bcv03r_ptr 
 );


unsigned char put_byte_ioport_bcv03r(
 PMLC_CMD_LIST *cmd_ptr, 
 unsigned char addr, 
 unsigned char data, 
 unsigned char *pdev_reg 
 );


unsigned char get_byte_ioport_bcv03r(
 PMLC_CMD_LIST *cmd_ptr, 
 unsigned char addr, 
 unsigned char *pdev_reg 
 );




















































typedef struct {
 unsigned char LNK_STAT_n0; 
 unsigned char LNK_STAT_n1; 
 unsigned char LNK_STAT_n2; 
 unsigned char LNK_STAT_n3; 
 unsigned char LNK_STAT_n4; 
 unsigned char LNK_STAT_r0; 
 unsigned char LNK_STAT_r1; 
 unsigned char LNK_STAT_r2; 
 unsigned char LNK_STAT_r3; 
 unsigned char LNK_STAT_r4; 
 } link_status;










unsigned char sys_get_pk_number();


unsigned char sys_get_clk_status();


unsigned char sys_get_pwr_status();


void sys_mc_clk_control();


void sys_wdt_restart();


void sys_led_control(
 unsigned char led_ctrl 
 );





void sys_set_timer_1(
 unsigned int tdelay 
 );


unsigned int sys_get_timer_1();


unsigned char sys_get_ovf_timer_1();





void sys_uart_select(
 unsigned char rxd_control 
 );


void sys_mko_drv_control(
 unsigned char mko_drv_ctrl 
 );


unsigned char sys_init_link_channel(
 unsigned char pk_num, 
 unsigned char pdev_num, 
 PMLC_CMD_LIST *cmd_ptr, 
 unsigned char *link_ptr 
 );






void sys_rom_page_select();














unsigned char sys_chk_prom_crc(
 unsigned short prog_len 
 );



















unsigned char sys_mem_chk_t1(
 unsigned char chk_value 
 );


unsigned char sys_mem_chk_t2(
 unsigned char chk_type 
 );


unsigned char sys_chk_mem_page(
 unsigned char mem_type, 
 unsigned char pg_num 
 );


void sys_set_mem_pg(
 unsigned char mem_type, 
 unsigned char pg_num 
 );


unsigned char sys_init_mem(
 unsigned char mem_type, 
 unsigned char m_size, 
 unsigned char *start_mem_pg, 
 unsigned char *end_mem_pg, 
 unsigned char *cur_mem_pg 
 );


unsigned char sys_next_mem_page(
 unsigned char mem_type, 
 unsigned char dir, 
 unsigned char *start_mem_pg, 
 unsigned char *end_mem_pg, 
 unsigned char *cur_mem_pg 
 );


unsigned char sys_sel_mem_page(
 unsigned char mem_type, 
 unsigned char new_pg, 
 unsigned char *start_mem_pg, 
 unsigned char *end_mem_pg, 
 unsigned char *cur_mem_pg 
 );






unsigned char data;
unsigned char led, i;



#pragma data_alignment=2
PMLC_CMD_LIST PMLC_TASK = {0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff};


#pragma data_alignment=2
bcv03r_type BCV03R_AN = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0};


void main (void) {
__NOP(); 
__NOP();
__NOP();


led = 0;
sys_led_control(0x00);


PMLC_baud_rate(0x0, &PMLC_TASK);

while (1) {
 for (i=0; i < 5; i=i++) {
 
 PMLC_select_device(0x00, i, &PMLC_TASK);
 
 PMLC_cmd_exec(&PMLC_TASK, 0x20, 0x04, 0x55, &(BCV03R_AN.IO_PORT_2));
 }

 for (i=0; i < 5; i=i++) {
 
 PMLC_select_device(0x80, i, &PMLC_TASK);
 
 PMLC_cmd_exec(&PMLC_TASK, 0x20, 0x04, 0x55, &(BCV03R_AN.IO_PORT_2));
 }

 __NOP(); 
 __NOP();
 __NOP();

 }
}

